/* test modules & menu lib.
 */

#include <stdio.h>
#include <unistd.h>
#include <mmm/modules.h>
#include <mmm/menu.h>

#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <mmm/libc_syms.h>

types_t types[]={ STD_TYPES, END_TYPES };

void err_insmod( int r, int fd, modules_t *mod, char *name )
{ modules_t *m;
  char buf[128];
	if( r< 0 )
	{	snprintf(buf,128,"load_module ERROR: %d\n",r);
		write(fd,buf,strlen(buf));
		if( r==E_UNDEF )
		{	m=modules_find_module(mod,name);
			if( m!=NULL )
				modules_print_undef(fd,m);
		}
	}
}

menu_t menu_cmd[]=	{
  {MENU_INIT,"cmd>|Bad command\n","?",NULL,NULL,NULL},
  {MENU_ITEM,"print","Vypis retazca","void",printf,
	  "char *fmt=%s%c,char *string, char nl=\n"},
  {MENU_ITEM,"disp","Vypis textu","void",printf,
	  "char *fmt=%s%c,char *text, char nl=\n"},
  {MENU_ITEM,"input","Necitanie textu","char *text",NULL,"char *text"},
  {MENU_EXIT,"exit","Exit from cmd menu",NULL,NULL,NULL},
  {MENU_END}
			};

menu_t menu[]=	{
  {MENU_INIT,"mod>|Invalid command\n","?","void mod",modules_start,
	  	"void syms"},
  {MENU_ITEM,"debug",NULL,NULL,printf,"char *fmt=c_MS=%d%c,int c_MS,char nl=\n"},
  {MENU_ITEM,"insmod","Insert new module","int r",modules_load_module,
  		"void mod, char *args, int c_NULL=0, int c_MS"},
  {MENU_ITEM|1,"insmod",NULL,"void",err_insmod,
  		"int r, int fd, void mod, char *args"},
  {MENU_ITEM,"rmmod","Remove module","int r",modules_remove_module,
  		"void mod, char *args"},
  {MENU_ITEM,"lsmod","List modules","int r",modules_print,
		"int fd, void mod, int level"},
  {MENU_ITEM,"ls","List modules","int r",modules_print,
		"int fd, void mod, int level=0"},
  {MENU_SUB|'/',"cmd","Submenu","char *text",menu_cmd,"char *text"},
  {MENU_EXIT,"exit","Exit",NULL,NULL,NULL},
  {MENU_EXIT,"quit",NULL,NULL,NULL,NULL},
  {MENU_FINISH,NULL,NULL,NULL,modules_stop,"void mod"},
  {MENU_END}
		};

mod_syms_t syms[]={
	SF(printf),
	SF(modules_print),
	SE
		  };

mod_syms_t *get_syms( void )
{	return(syms);
}

int main( int argc, char *argv[] )
{ vars_t *vars;
  	if( (vars=var_init(types))!=NULL )
	{	var_set(vars,"void syms",(long)libc_syms);
		var_set(vars,"int c_MS",(long)MS_AUTOINIT|MS_AUTOCLEAN);
		menu_text_command(menu_init(0,NULL,menu,vars));
	}
/*
  int a,r;
  modules_t *mod,*m;
  	if( (mod=modules_start(syms))==NULL )
	{	printf("Fatal Error\n");
		return(-1);
	}
  	a=1;
  	while( a<argc )
	{	r=modules_load_module(mod,argv[a],NULL,MS_AUTOINIT|MS_AUTOCLEAN);
		if( r< 0 )
		{	printf("load_module ERROR: %d\n",r);
			if( r==E_UNDEF )
			{	m=modules_find_module(mod,argv[a]);
				if( m!=NULL )
					modules_print_undef(0,m);
			}
		}
		a++;
	}
	modules_stop(mod);
*/
	return(0);
}

