/* Memory in file
 * (c)24.10.1999 by Marek Zelem
 */

#ifndef _FMEMORY_H
#define _FMEMORY_H

#define	FMEMADDR_FILEID	0xff000000
#define	FMEMADDR_BLOKID	0x00ffffff	/* *16=offset */
#define	NOMEMID		0xffffffff

#define	ALIGN16(x)	(((x)+15)&~15)

struct fmem_head_s	{
	long	magic;	/* 0x1ef1f11e */
	long	file_magic_id;	/* 0-255 <<24 - offset indexu */
	long	first_offset;
	long	free;		/* total free */
	int	mutex[4];
			};

struct fmem_blok_head_s	{
	long	size;
	long	prev;
	unsigned short usecount;
	unsigned short user_id;
	long	user_adr;
			};

struct fmem_file_s	{
	char	*filename;
	int	fd;
	long	size;
	struct fmem_head_s	*mem;
			};

typedef struct fmem_s	{
	void(*destroy)(struct fmem_s *);
	int(*create_file)(struct fmem_s *,char *,int id,long size);
	int(*add_file)(struct fmem_s *,char *);
	void*(*get)(struct fmem_s *,long addr);
	long(*get_size)(struct fmem_s *,long addr);
	long(*malloc)(struct fmem_s *,long size,int memid);
	long(*realloc)(struct fmem_s *,long addr, long size);
	int(*free)(struct fmem_s *,long addr);
	struct fmem_blok_head_s*(*head)(struct fmem_s *,long addr);
	struct fmem_head_s*(*file_head)(struct fmem_s *,int memid);
	int	files;
	int	max_files;
	unsigned char fileid_trans_table[256]; /* file_magic_id -> file index */
	struct fmem_file_s	file[0];
			} fmem_t;

fmem_t *fmem_create( int max_files );
extern int fmem_errno;
#define	FME_OK		0
#define	FME_MUTEX	64

#endif _FMEMORY_H

