/* Indexed Memory in file
 * (c)31.10.1999 by Marek Zelem
 */

#ifndef _IMEMORY_H
#define _IMEMORY_H

#include <mmm/fmemory.h>

typedef struct imem_s	{
	void(*destroy)(struct imem_s *);
	int(*create_index)(struct imem_s *,int memid);
	long(*new)(struct imem_s *,long size,int memid);
	void*(*get)(struct imem_s *,long id);
	long(*size)(struct imem_s *,long id);
	int(*resize)(struct imem_s *,long id, long size);
	int(*inc_use)(struct imem_s *,long id);
	int(*dec_use)(struct imem_s *,long id);
	fmem_t	*fmem;
			} imem_t;

imem_t *imem_create( fmem_t *fmem );
extern int imem_errno;
#define	IME_OK		0
#define	IME_MUTEX	64


#endif _IMEMORY_H
