/* Logic lib		*/
/* (c) by Marek Zelem	*/

#ifndef	_LOGIC_H
#define	_LOGIC_H

#ifndef	NULL
#define	NULL	((void*)0)
#endif	NULL

/* Univerzalny Stavovy Automat  */

typedef struct 	{
			int	state;
			int(*func)(void*);	/* func returns new state */
						/* zero is END, -1 is ERR */
		} automat_status_t;

typedef struct	{
			void	*data;	/* for user's use */
			void(*free)(void*);
			automat_status_t	*states;
			int	actual_state;
		} automat_t;

automat_t *automat_create( automat_status_t *states );
automat_status_t *automat_destroy( automat_t *au );
int automat_set_data( automat_t *au, void *data, void(*datafree)(void*) );
int automat_start( automat_t *au, int state );

#endif	_LOGIC_H

