/* ionet_lib.c	  */
/* (c) by Marek Zelem */

#include <errno.h>
#include <mmm/io_lib.h>
#include <mmm/net_lib.h>
#include <mmm/ionet_lib.h>

/* iof_accept
 * accept from fd, create new io, ptr is new prototyp
 */
int iof_accept( io_t *io, int what, void *arg )
{ int s;
  io_t *p;
	if( what==IO_RD )
	{	if( (s=net_accept(io->rd,NULL,NULL,NULL))<0 )
			return(-1); /* end of this task */
		((io_t*)(io->ptr))->rd=s;
		((io_t*)(io->ptr))->wr=s;
		if( (p=io_add(io,io->ptr))==NULL )
		{	net_close(s);	return(0);	}
	}
	else if( what==IO_INIT )
	{	if( io->inbuf==NULL )	io->inbuf=(void*)1;
	}
	return(0);
}

/* ionet_connect
 * create new io by prototyp, with rd & wr connected
 * to addr , port
 */
int ionet_connect( io_t *io, io_t *prototyp, unsigned int addr, int port )
{ int s,r;
  io_t *p;
	if( (s=socket(PF_INET,SOCK_STREAM,0))<0 )	return(-1);
	net_s_noblock(s);
	if( (r=net_gnrl_connect(s,addr,port))>=0
		|| ( r<0 && errno==EINPROGRESS ) )
	{	prototyp->rd=s;
		prototyp->wr=s;
		if( (p=io_add(io,prototyp))==NULL )
		{	net_close(s);	return(-2);	}
	}
	else
	{	close(s);
		return(-1);
	}
	return(0);
}

io_t _prototyp_accept=	proto_io(
				100,			/* prior */
				iof_accept,NULL,	/* func, ufn */
				NULL,NULL		/* ptr, ptr2 */
				);

/* ionet_bind
 * create new io accepting on port port, which create new io by prototyp,
 * with rd & wr socket.
 */
int ionet_bind( io_t *io, io_t *prototyp, int port )
{ int s;
  io_t *p;
	if( (s=net_bind(port))<0 )	return(-1);
	_prototyp_accept.rd=s;
	_prototyp_accept.wr=s;
	_prototyp_accept.ptr=prototyp;
	if( (p=io_add(io,&_prototyp_accept))==NULL )
	{	net_close(s);	return(-2);	}
	return(0);
}


