/* Univerzalny Stavovy Automat	*/
/* (c) by Marek Zelem		*/

#include <stdlib.h>
#include <mmm/logic.h>

automat_t *automat_create( automat_status_t *states )
{ automat_t *au;
	if( (au=malloc(sizeof(automat_t)))==NULL )
		return(NULL);
	au->data=NULL;
	au->free=NULL;
	au->states=states;
	au->actual_state=0;
	return(au);
}

automat_status_t *automat_destroy( automat_t *au )
{ automat_status_t *states;
	if( au->free!=NULL && au->data!=NULL )
		au->free(au->data);
	states=au->states;
	free(au);
	return(states);
}

int automat_set_data( automat_t *au, void *data, void(*datafree)(void*) )
{
	if( au->free!=NULL && au->data!=NULL )
		au->free(au->data);
	au->data=data;
	au->free=datafree;
	return(0);
}

int automat_start( automat_t *au, int state )
{ int i;
	do {	i=0;
		while( au->states[i].func!=NULL && au->states[i].state!=state )
			i++;
		if( au->states[i].func==NULL )	return(-1000);
		au->actual_state=state;
		state=au->states[i].func(au->data);
	   } while( state>0 );
	return( state );
}

