/* User Interface - Menu
 * (c) by Marek Zelem
 */

#ifndef _MENU_H
#define	_MENU_H

#include <stdio.h>
#include <ctype.h>

#define	TYPESIZE_VAR		-1
#define	TYPESIZE_UNKNOWN	0

struct typehandler_t	{
	long (*input)( int fd, int size );
	void (*print)( int fd, long, int size );
	void (*free)( long, int size );
			};

typedef struct	{
	char			*name;
	struct typehandler_t	*handler;
		} types_t;

extern struct typehandler_t
			th_s_char,th_s_short,th_s_int,th_s_long,
			th_u_char,th_u_short,th_u_int,th_u_long,
			th_s_char_p,th_u_char_p;

#define	END_TYPES	{NULL,NULL}
#define STD_TYPES	{"char",&th_s_char},\
			{"char *",&th_s_char_p},\
			{"signed char *",&th_s_char_p},\
			{"unsigned char *",&th_u_char_p},\
			{"short",&th_s_short},\
			{"short int",&th_s_short},\
			{"int",&th_s_int},\
			{"long",&th_s_long},\
			{"long int",&th_s_long},\
			{"signed char",&th_s_char},\
			{"signed short",&th_s_short},\
			{"signed short int",&th_s_short},\
			{"signed int",&th_s_int},\
			{"signed",&th_s_int},\
			{"signed long",&th_s_long},\
			{"signed long int",&th_s_long},\
			{"unsigned char",&th_u_char},\
			{"unsigned short",&th_u_short},\
			{"unsigned short int",&th_u_short},\
			{"unsigned int",&th_u_int},\
			{"unsigned",&th_u_int},\
			{"unsigned long",&th_u_long},\
			{"unsigned long int",&th_u_long},\
			{"s_char",&th_s_char},\
			{"s_short",&th_s_short},\
			{"s_int",&th_s_int},\
			{"s_long",&th_s_long},\
			{"u_char",&th_u_char},\
			{"u_short",&th_u_short},\
			{"u_int",&th_u_int},\
			{"u_long",&th_u_long}

/* name je deklaracia premennej aj s menom.
 * priklad: "unsigned int pole[3]"
 */
char *type_name( const char *name );
char *type_varname( const char *name );
int type_size( const char *name );

long type_input( int fd, const char *name, types_t *types );
int type_print( int fd, const char *name, types_t *types, long d );
int type_free( const char *name, types_t *types, long d );

typedef struct	{
	char	*type;		/* ak type ==NULL ,tak koniec */
	int	offset;
	int	len;		/* 1-4 bytes ; -1 - pointer sem */
		} struct_t;

/* asi zle
#define STRUCT_MEMBER(stru,mem)	\
	{#mem,(int)(&((((stru) *)0)->(mem))),sizeof((((stru) *)0)->(mem)) }
*/

#endif	_MENU_H

