/* text library ver.0.1 */
/* (c)1997 by Marek Zelem	*/

#include <stdio.h>
#include <ctype.h>
#include <mmm/text_lib.h>
#include <mmm/backslash.h>
//#define	tex_parse_backslash(bslash,len)	backslash_parse((bslash),(len))

int tex_verlib( char *buf )
{
	strcpy(buf,"Text Library ver.0.1 (c)24.10.1997 by Marek Zelem");
	return(0x0001);
}


int tex_isoneof( char c, char *s )
{
	while(*s!=0 && *s!=c)	s++;
	return( (*s==c) );
}

void tex_charfd_zero( char_fd_t *char_fd )
{ int i;
	for(i=0;i<(256>>3);i++)	(*char_fd)[i]=0;
}

void tex_charfd_fill( char_fd_t *char_fd )
{ int i;
	for(i=0;i<(256>>3);i++)	(*char_fd)[i]=~0;
}

void tex_charfd_set( unsigned char c, char_fd_t *char_fd )
{	((*char_fd)[c>>3])|=(1<<(c&0x7));
}

void tex_charfd_clr( unsigned char c, char_fd_t *char_fd )
{	((*char_fd)[c>>3])&=~(1<<(c&0x7));
}

int tex_charfd_isset( unsigned char c, char_fd_t *char_fd )
{
	return( (((*char_fd)[c>>3])&(1<<(c&0x7))) ? 1 : 0  );
}

int tex_charfd_init( char *init, char_fd_t *char_fd )
{ int i,m;
  unsigned char pc,c,x;
  long l;
	m=1; tex_charfd_zero(char_fd);
	i=0;
	if( init[i]=='!' )
	{	tex_charfd_fill(char_fd);	i++;	m=0;	}
	pc=0;
	while( (c=init[i])!=0 && c!=']' )
	{	i++;
		if( c=='-' && m<100 )	{ m+=100; continue; }
		if( c=='\\' )
		{	c=tex_parse_backslash(init+i-1,&l);
			i+=l-1;
		}
		if( m>=100 )
		{	m-=100;
			if( c < pc )	{ x=c; c=pc; pc=x; }
			for(x=pc;x<=c;x++)
			{	if(m)	tex_charfd_set(x,char_fd);
				else	tex_charfd_clr(x,char_fd);
			}
		}
		if(m)	tex_charfd_set(c,char_fd);
		else	tex_charfd_clr(c,char_fd);
		pc=c;
	}
	if( m>=100 )
	{	m-=100;
		for(x=pc;x<=255;x++)
		{	if(m)	tex_charfd_set(x,char_fd);
			else	tex_charfd_clr(x,char_fd);
		}
	}
	return(i);
}


/* bslash - smernik na \\ , ak len!=NULL potom vrati dlzku sekvencie */
/* RETURN VALUE: ascii kod znaku */
/* char tex_parse_backslash( const char *bslash, long *len ) */


int tex_open( text_t *tt, char *start, long len )
{
	tt->start=start;
	tt->len=len;
	tt->p=tt->l=start;
	return(1);
}

int tex_close( text_t *tt, char **start, long *len )
{
	if( start!=NULL )	*start=tt->start;
	if( len!=NULL )		*len=tt->len;
	return(1);
}

void tex_discardline( text_t *tt )
{ char *e;
	e=tt->start+tt->len;
	while(tt->p<e && *(tt->p)!='\n' )  tt->p++;
	if(tt->p<e)  tt->p++;
}

void tex_ldiscardseparators( text_t *tt, char *separators )
{ char *e;
	e=tt->start+tt->len;
	while(tt->p<e && tex_isoneof(*(tt->p),separators) )  tt->p++;
}

int tex_lgetword( text_t *tt, char *buf, long len, char *separators )
{ char *e;
  int s,i;
	s= -1;
	e=tt->start+tt->len;
	i=0;
	if(tt->p<e && *(tt->p)=='\"')
	{ tt->p++; 
          while(tt->p<e && i<len && *(tt->p)!='\"' &&  *(tt->p)!='\n')
		 buf[i++]=*(tt->p++);
	  if( *(tt->p)=='\"' )	s= TEX_W1;
	  else			s= TEX_WERR;
	}
	else if(tt->p<e && *(tt->p)=='\'')
	{ tt->p++; 
          while(tt->p<e && i<len && *(tt->p)!='\'' &&  *(tt->p)!='\n')
		 buf[i++]=*(tt->p++);
	  if( *(tt->p)=='\'' )	s= TEX_W2;
	  else			s= TEX_WERR;
	}
	else if(tt->p<e && *(tt->p)=='`')
	{ tt->p++; 
          while(tt->p<e && i<len && *(tt->p)!='`' &&  *(tt->p)!='\n')
		 buf[i++]=*(tt->p++);
	  if( *(tt->p)=='`' )	s= TEX_W3;
	  else			s= TEX_WERR;
	}
	else
	{
	  while(tt->p<e && i<len && !tex_isoneof(*(tt->p),separators))  buf[i++]=*(tt->p++);
	  s= TEX_W0;
	}

	if(i<len)	buf[i]=0; 
	else		{ buf[len-1]=0; s=TEX_WERR; }
	if(tt->p>=e)	s=TEX_WERR;
	return(s);
}

int tex_lgetline( text_t *tt, char *buf, long len )
{ char *e;
  int s,i;
	e=tt->start+tt->len;
	i=0;
	while(tt->p<e && i<len && *(tt->p)!='\n')	buf[i++]=*(tt->p++);
	if( *(tt->p)=='\n' )	tt->p++;
	if(i<len)	{ buf[i]=0; s=TEX_W0; }
	else		{ buf[len-1]=0; s=TEX_WERR; }
	return(s);
}

char tex_lgetchar( text_t *tt )
{ char *e;
	e=tt->start+tt->len;
	if(tt->p<e && *(tt->p)!='\n')	return(*(tt->p++));
	return(0);
}

int tex_iseol( text_t *tt )
{ char *e;
	e=tt->start+tt->len;
	if(tt->p<e && *(tt->p)=='\n')	return(1);
	return(0);
}

int tex_isend( text_t *tt )
{
	return(tt->p>=(tt->start+tt->len));
}

long tex_getpos( text_t *tt )
{
	return(tt->p-tt->start);
}

int tex_setpos( text_t *tt, long pos )
{
	if( pos>=tt->len )	return(0);
	tt->p=tt->start+pos;
	return(1);
}


/* ------- test ------- */


